## net.sf.saxon.functions
Class Minimax

    java.lang.Object
      net.sf.saxon.expr.Expression
          net.sf.saxon.expr.FunctionCall
              net.sf.saxon.functions.SystemFunction
                  net.sf.saxon.functions.CollatingFunction
                      net.sf.saxon.functions.Minimax

All Implemented Interfaces:
  java.io.Serializable, javax.xml.transform.SourceLocator, LocationProvider, SaxonLocator, EvaluableItem, SequenceIterable, InstructionInfo, org.xml.sax.Locator

    public class Minimax

extends CollatingFunction

This class implements the min() and max() functions

See Also:
  Serialized Form

Field Summary
`static int` `MAX`
`static int` `MIN`

Fields inherited from class net.sf.saxon.functions.CollatingFunction
`stringCollator`

Fields inherited from class net.sf.saxon.functions.SystemFunction
`operation`

Fields inherited from class net.sf.saxon.expr.FunctionCall
`argument`

Fields inherited from class net.sf.saxon.expr.Expression
`EVALUATE_METHOD, ITERATE_METHOD, locationId, PROCESS_METHOD, staticProperties`

Constructor Summary
`Minimax()`

Method Summary
`void` `checkArguments(ExpressionVisitor visitor)` Static analysis: prevent sorting of the argument
`int` `computeCardinality()` Determine the cardinality of the function.
`Item` `evaluateItem(XPathContext context)` Evaluate the function
`ItemType` `getItemType(TypeHierarchy th)` Determine the item type of the value returned by the function
`boolean` `isIgnoreNaN()` Test whether NaN values are to be ignored
`static AtomicValue` `minimax(SequenceIterator iter, int operation, AtomicComparer atomicComparer, boolean ignoreNaN, XPathContext context)` Static method to evaluate the minimum or maximum of a sequence
`Expression` `optimize(ExpressionVisitor visitor, ItemType contextItemType)` Perform optimisation of an expression and its subexpressions.
`void` `setIgnoreNaN(boolean ignore)` Indicate whether NaN values should be ignored.

Methods inherited from class net.sf.saxon.functions.CollatingFunction
`copy, getAtomicComparer, getCollator, getExpressionBaseURI, getStringCollator`

Methods inherited from class net.sf.saxon.functions.SystemFunction
`addContextDocumentArgument, addDocToPathMap, computeSpecialProperties, getDetails, getErrorCodeForTypeErrors, getRequiredType, makeSystemFunction, setDetails, useContextItemAsDefault`

Methods inherited from class net.sf.saxon.expr.FunctionCall
`addExternalFunctionCallToPathMap, checkArgumentCount, equals, explain, getArguments, getDisplayName, getFunctionName, getNumberOfArguments, hashCode, iterateSubExpressions, preEvaluate, promote, replaceSubExpression, setArguments, setFunctionName, simplify, simplifyArguments, toString, typeCheck`

Methods inherited from class net.sf.saxon.expr.Expression

`addToPathMap, adoptChildExpression, checkForUpdatingSubexpressions, checkPermittedContents, computeDependencies, computeStaticProperties, display, doPromotion, dynamicError, effectiveBooleanValue, evaluateAsString, evaluatePendingUpdates, explain, findParentOf, getCardinality, getColumnNumber, getColumnNumber, getConstructType, getContainer, getDependencies, getExecutable, getHostLanguage, getImplementationMethod, getIntrinsicDependencies, getLineNumber, getLineNumber, getLocationId, getLocationProvider, getObjectName, getProperties, getProperty, getPublicId, getSlotsUsed, getSpecialProperties, getSystemId, getSystemId, hasLoopingSubexpression, implementsStaticTypeCheck, isUpdatingExpression, iterate, iterateEvents, markTailFunctionCalls, process, resetLocalStaticProperties, setContainer, setFiltered, setFlattened, setLocationId, staticTypeCheck, suppressValidation, typeError`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Field Detail

### MIN

    public static final int MIN

See Also:
  Constant Field Values

### MAX

    public static final int MAX

See Also:
  Constant Field Values

Constructor Detail

### Minimax

    public Minimax()

Method Detail

### setIgnoreNaN

    public void setIgnoreNaN(boolean ignore)

  Indicate whether NaN values should be ignored. For the external min() and max() function, a NaN value in the input causes the result to be NaN. Internally, however, min() and max() are also used in such a way that NaN values should be ignored.

  Parameters:
    `ignore` - true if NaN values are to be ignored when computing the min or max.

### isIgnoreNaN

    public boolean isIgnoreNaN()

  Test whether NaN values are to be ignored

  Returns:
    true if NaN values are to be ignored. This is the case for internally-generated min() and max() functions used to support general comparisons

### checkArguments

    public void checkArguments(ExpressionVisitor visitor)
                        throws XPathException

  Static analysis: prevent sorting of the argument

  Overrides:
    `checkArguments` in class `CollatingFunction`
  Parameters:
    `visitor` - the expression visitor
  Throws:
    `XPathException`

### computeCardinality

    public int computeCardinality()

  Determine the cardinality of the function.

  Overrides:
    `computeCardinality` in class `SystemFunction`
  Returns:
    the computed cardinality, as one of the values `StaticProperty.ALLOWS_ZERO_OR_ONE`, `StaticProperty.EXACTLY_ONE`, `StaticProperty.ALLOWS_ONE_OR_MORE`, `StaticProperty.ALLOWS_ZERO_OR_MORE`

### optimize

    public Expression optimize(ExpressionVisitor visitor,
                               ItemType contextItemType)
                        throws XPathException

  Perform optimisation of an expression and its subexpressions.

  This method is called after all references to functions and variables have been resolved to the declaration of the function or variable, and after all type checking has been done.

  Overrides:
    `optimize` in class `SystemFunction`
  Parameters:
    `visitor` - an expression visitor
    `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
  Returns:
    the original expression, rewritten if appropriate to optimize execution
  Throws:
    `XPathException` - if an error is discovered during this phase (typically a type error)

### getItemType

    public ItemType getItemType(TypeHierarchy th)

  Determine the item type of the value returned by the function

  Overrides:
    `getItemType` in class `SystemFunction`
  Parameters:
    `th` - the type hierarchy cache
  Returns:
    the statically inferred type of the expression

### evaluateItem

    public Item evaluateItem(XPathContext context)
                      throws XPathException

  Evaluate the function

  Specified by:
    `evaluateItem` in interface `EvaluableItem`
  Overrides:
    `evaluateItem` in class `Expression`
  Parameters:
    `context` - The context in which the expression is to be evaluated
  Returns:
    the node or atomic value that results from evaluating the expression; or null to indicate that the result is an empty sequence
  Throws:
    `XPathException` - if any dynamic error occurs evaluating the expression

### minimax

    public static AtomicValue minimax(SequenceIterator iter,
                                      int operation,
                                      AtomicComparer atomicComparer,
                                      boolean ignoreNaN,
                                      XPathContext context)
                               throws XPathException

  Static method to evaluate the minimum or maximum of a sequence

  Parameters:
    `iter` - Iterator over the input sequence
    `operation` - either `MIN` or `MAX`
    `atomicComparer` - an AtomicComparer used to compare values
    `ignoreNaN` - true if NaN values are to be ignored
    `context` - dynamic evaluation context
  Returns:
    the min or max value in the sequence, according to the rules of the fn:min() or fn:max() functions
  Throws:
    `XPathException` - typically if non-comparable values are found in the sequence

Copyright (c) Saxonica Limited. All rights reserved.